<template>
  <SfModal class="sw-gs-end-appointment-modal" :visible="isEndAppointmentModalOpen" @close="toggleModal">
    <p>
      {{ $t('Are you sure you want to end this appointment for yourself and for all clients?') }}
    </p>

    <div class="sw-gs-end-appointment-modal-actions">
      <SwButton class="sw-gs-end-presentation-btn color-danger"
                :title="$t('End appointment')"
                @click="endAppointment">
        {{ $t('End appointment') }}
      </SwButton>
      <SwButton class="sw-gs-end-presentation-cancel-btn color-light"
                :title="$t('Cancel')"
                @click="toggleModal(false)">
        {{ $t('Cancel') }}
      </SwButton>
    </div>
  </SfModal>
</template>

<script lang="ts">
  import {SfModal} from "@storefront-ui/vue"
  import SwButton from "@/components/atoms/SwButton.vue";
  import {useUIState} from "@shopware-pwa/composables";
  import {useAppointment} from "../../logic/composables/useAppointment";
  import {useClearBodyScrollLock} from "../../logic/composables/useClearBodyScrollLock";

  export default {
    name: "SwGsEndAppointmentModal",
    components: {
      SfModal,
      SwButton
    },
    setup() {
      const {isOpen: isEndAppointmentModalOpen, switchState: toggleModal} = useUIState({stateName: `GS_END_APPOINTMENT_MODAL_STATE`});
      const {end} = useAppointment();

      const endAppointment = async () => {
        await end();
        toggleModal(false);
      }

      useClearBodyScrollLock();

      return {
        isEndAppointmentModalOpen,
        toggleModal,
        endAppointment
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/variables";

  .sw-gs-end-appointment-modal {
    .sw-gs-end-appointment-modal-actions {
      display: flex;
    }

    .sw-gs-end-presentation-btn {
      margin-right: var(--spacer-sm);
    }

    ::v-deep .sf-modal__container {
      z-index: var(--modal-container-z-index);
    }

    ::v-deep .sf-modal__overlay {
      z-index: var(--modal-overlay-z-index);
    }
  }
</style>
